#include "cosmo.h"
#include <commdlg.h>
 
 
 
/* 
 * FSaveOpenDialog 
 * 
 * Purpose: 
 *  Invokes the COMMDLG.DLL GetOpenFileName dialog and retrieves 
 *  a filename for saving or opening. 
 * 
 * Parameters: 
 *  hWnd            HWND of the owning application. 
 *  hInst           HINSTANCE of the application instance. 
 *  pszExt          LPSTR of the default extension 
 *  pszFilter       LPSTR of the filter desciption. 
 *  pszFile         LPSTR buffer to receive the entered filename. 
 *                  Must be at least CCHPATHMAX long. 
 *  fOpen           BOOL indicating if we want file open or save. 
 * 
 * Return Value: 
 *  BOOL            TRUE if the function retrieved a filename, 
 *                  FALSE if the user pressed CANCEL. 
 */ 

LPSTR ext = "9xy";
LPSTR fil = "fichiers Graphlink 92+(9xy,9xz)\0*.9xy;*.9xz\0fichiers Graphlink 89(89y,89z)\0*.89y;*.89z\0\0";
LPSTR opn;

BOOL WINAPI FSaveOpenDialog(HWND hWnd, HINSTANCE hInst
    , LPSTR pszFilter, LPSTR pszFile, LPSTR pszCaption, BOOL fOpen) 
    { 
    OPENFILENAME    ofn; 
    char            szTitle[CCHFILENAMEMAX]; 
    char            *szFilter = pszFilter;
    UINT            cch1; 
    UINT            cch2; 
 
    ofn.lStructSize      =sizeof(OPENFILENAME); 
    ofn.hwndOwner        =hWnd; 
    ofn.hInstance        =hInst; 
 
    ofn.lpstrFilter      =szFilter; 
    ofn.lpstrCustomFilter=NULL; 
    ofn.nMaxCustFilter   =0L; 
    ofn.nFilterIndex     =1L;                //We only have 1 extension. 
 
    ofn.lpstrFile        =pszFile; 
    ofn.nMaxFile         =CCHPATHMAX; 
    ofn.lpstrFileTitle   =(LPSTR)szTitle; 
    ofn.nMaxFileTitle    =CCHFILENAMEMAX; 
 
    ofn.lpstrInitialDir  =NULL; 
    ofn.lpstrTitle       =pszCaption; 
 
    ofn.Flags            =OFN_HIDEREADONLY; 
    ofn.nFileOffset      =0; 
    ofn.nFileExtension   =0; 
    ofn.lpstrDefExt      =ext;
    ofn.lCustData        =0; 
    ofn.lpfnHook         =NULL; 
    ofn.lpTemplateName   =NULL; 
 
 
    //Modify the flags as appropriate. 
    if (fOpen) 
        ofn.Flags        |= OFN_FILEMUSTEXIST; 
    else 
        ofn.Flags        |= OFN_PATHMUSTEXIST | OFN_OVERWRITEPROMPT; 
 
 
 
    return GetOpenFileName(&ofn);
    } 

